# snapshotver is year-month-day-svnrevision, generated by "make dist"
%define snapshot        1
%define snapshotversion 201004234031
%define version         1.0.90
%define rel             2

Name:    tigervnc
Version: %{version}
%define subrel 1
%if %{snapshot}
Release: %mkrel 0.%{snapshotversion}.%{rel}
%else
Release: %mkrel %{rel}
%endif

License:   GPLv2+
URL:       http://www.tigervnc.com/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Source0: %{name}-%{version}.tar.gz
Source1: vncviewer.desktop
# Missing from "make dist":
Source2: %{name}-media.tar.gz

Source3: vncserver-initscript
Source4: sysconfig-vncservers

BuildRequires: x11-server-source
BuildRequires: gettext-devel
BuildRequires: libx11-devel
BuildRequires: libxext-devel
BuildRequires: x11-util-macros
BuildRequires: x11-xtrans-devel
BuildRequires: mesagl-devel
BuildRequires: libxkbfile-devel
BuildRequires: libxfont-devel
BuildRequires: pixman-devel
BuildRequires: openssl-devel
BuildRequires: libpciaccess-devel
BuildRequires: libpam-devel
BuildRequires: libxtst-devel
BuildRequires: gnutls-devel
BuildRequires: imagemagick
BuildRequires: nasm

#------------------------------------------------------------------------------

# package tigervnc

Summary: A remote display system
Group:   System/X11

%description
Virtual Network Computing (VNC) is a remote display system which
allows you to view a computing 'desktop' environment not only on the
machine where it is running, but from anywhere on the Internet and
from a wide variety of machine architectures.  This package contains a
client which will allow you to connect to other desktops running a VNC
server.

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc unix/README
%{_bindir}/vncviewer
%{_datadir}/icons/*
%{_datadir}/applications/*
%{_mandir}/man1/vncviewer.1*


#------------------------------------------------------------------------------

%package server

Summary: A remote display system's server
Group:   System/X11

Requires(post):  rpm-helper
Requires(preun): rpm-helper

%description server
The VNC system allows you to access the same desktop from a wide
variety of platforms.  This package is a TigerVNC server, allowing
others to access the desktop on your machine.

%files server
%defattr(-,root,root,-)
%{_bindir}/vncconfig
%{_bindir}/vncpasswd
%{_bindir}/x0vncserver
%{_bindir}/Xvnc
%{_bindir}/vncserver
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncpasswd.1*
%{_mandir}/man1/vncconfig.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/x0vncserver.1*
%{_initrddir}/vncserver
%config(noreplace) %{_sysconfdir}/sysconfig/vncservers

%post server
%_post_service vncserver

%preun server
%_preun_service vncserver


#------------------------------------------------------------------------------

%package server-module

Summary:  the remote display system module to Xorg
Group:    System/X11

Requires: x11-server-xorg

%description server-module
This package contains libvnc.so module to X server, allowing others
to access the desktop on your machine.

%files server-module
%defattr(-,root,root,-)
%{_libdir}/xorg/modules/extensions/libvnc.so

#------------------------------------------------------------------------------

%prep
%setup -q
%setup -a 2

cp -r /usr/share/x11-server-source/* unix/xserver
pushd unix/xserver
for all in `find . -type f -perm -001`; do
	chmod -x "$all"
done
patch -p1 -b --suffix .vnc < ../xserver17.patch

popd


# Use newer gettext
sed -i 's/AM_GNU_GETTEXT_VERSION.*/AM_GNU_GETTEXT_VERSION([0.17])/' \
	configure.ac

%build
# Temporary build with -fno-omit-frame-pointer, it causes problems
export CFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer"
export CXXFLAGS="$CFLAGS"

autoreconf -fiv
%configure --disable-static
%make

# XXX: I'm not sure this define is actually needed
# Need this for shared objects that reference X Server, or other modules symbols
%define _disable_ld_no_undefined 1
# Search for modules in extra_module_dir before the default path.
# This will allow fglrx to install its modified modules in more cleaner way.
%define extra_module_dir %{_libdir}/xorg/extra-modules

pushd unix/xserver
autoreconf -fiv

# After the "--disable-config-hal", most options are just a paste from
# Mandriva's x11-server. We need to check what we can clean here (without
# reducing features)
%configure2_5x  --disable-xorg \
		--disable-xwin \
		--disable-xvfb \
		--disable-xnest \
		--disable-dmx \
		--disable-xsdl \
		--disable-xfbdev \
		--disable-xephyr \
		--disable-kdrive \
		--disable-config-dbus \
		--disable-config-hal \
		--with-log-dir=%{_logdir} \
		--with-os-vendor="Mandriva" \
		--with-os-name="`echo \`uname -s -r\` | sed -e s'/ /_/g'`" \
		--with-vendor-web="http://qa.mandriva.com" \
		--with-extra-module-dir=%{extra_module_dir} \
		--enable-xwrapper \
		--enable-pam \
		--with-fontdir="%{_datadir}/fonts" \
		--with-default-font-path="catalogue:%{_sysconfdir}/X11/fontpath.d"

%make
popd

# Build icons
pushd media
%make
popd

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

pushd unix/xserver/hw/vnc
make install DESTDIR=$RPM_BUILD_ROOT
popd

# Install desktop stuff
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/{16x16,24x24,48x48}/apps

pushd media/icons
for s in 16 24 48; do
install -m644 tigervnc_$s.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/${s}x$s/apps/tigervnc.png
done
popd

mkdir $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install \
	--dir $RPM_BUILD_ROOT%{_datadir}/applications \
	%{SOURCE1}

%find_lang %{name} %{name}.lang

# remove unwanted files
rm -f  $RPM_BUILD_ROOT%{_libdir}/xorg/modules/extensions/libvnc.la

# Install initscript and vncservers:
install -D -m 644 %{_sourcedir}/sysconfig-vncservers \
                  %{buildroot}/%{_sysconfdir}/sysconfig/vncservers
install -D -m 755 %{_sourcedir}/vncserver-initscript \
                  %{buildroot}/%{_initrddir}/vncserver


%clean
rm -rf $RPM_BUILD_ROOT



%changelog
* Mon Jan 03 2011 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201004234031.2.1mdv2010.1
+ Revision: 628022
- Add initscript and sysconfig files
  CCBUG: 60220

* Wed May 05 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201004234031.2mdv2010.1
+ Revision: 542633
- Remove sed in Makefile.am (was breaking libvnc.so)
- Add URL tag

* Fri Apr 23 2010 Paulo Ricardo Zanoni <pzanoni@mandriva.com> 1.0.90-0.201004234031.1mdv2010.1
+ Revision: 538366
- import tigervnc

